/[gentoo-x86]/eclass/haskell-cabal.eclass
Gentoo

Contents of /eclass/haskell-cabal.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.39 - (hide annotations) (download)
Sun Apr 28 16:15:33 2013 UTC (11 months, 3 weeks ago) by zmedico
Branch: MAIN
Changes since 1.38: +4 -4 lines
Bug #467646 - Refer to /etc/portage/make.conf, not /etc/make.conf.

1 slyfox 1.38 # Copyright 1999-2013 Gentoo Foundation
2 kosmikus 1.1 # Distributed under the terms of the GNU General Public License v2
3 zmedico 1.39 # $Header: /var/cvsroot/gentoo-x86/eclass/haskell-cabal.eclass,v 1.38 2013/01/06 13:06:35 slyfox Exp $
4 vapier 1.25
5     # @ECLASS: haskell-cabal.eclass
6     # @MAINTAINER:
7     # Haskell herd <haskell@gentoo.org>
8     # @AUTHOR:
9     # Original author: Andres Loeh <kosmikus@gentoo.org>
10     # Original author: Duncan Coutts <dcoutts@gentoo.org>
11     # @BLURB: for packages that make use of the Haskell Common Architecture for Building Applications and Libraries (cabal)
12     # @DESCRIPTION:
13 kosmikus 1.1 # Basic instructions:
14     #
15     # Before inheriting the eclass, set CABAL_FEATURES to
16     # reflect the tools and features that the package makes
17     # use of.
18     #
19     # Currently supported features:
20     # haddock -- for documentation generation
21 kolmodin 1.21 # hscolour -- generation of colourised sources
22 slyfox 1.35 # hoogle -- generation of documentation search index
23 kosmikus 1.1 # alex -- lexer/scanner generator
24     # happy -- parser generator
25     # c2hs -- C interface generator
26     # cpphs -- C preprocessor clone written in Haskell
27     # profile -- if package supports to build profiling-enabled libraries
28     # bootstrap -- only used for the cabal package itself
29 dcoutts 1.3 # bin -- the package installs binaries
30     # lib -- the package installs libraries
31 kolmodin 1.16 # nocabaldep -- don't add dependency on cabal.
32 slyfox 1.23 # only used for packages that _must_ not pull the dependency
33     # on cabal, but still use this eclass (e.g. haskell-updater).
34 slyfox 1.32 # test-suite -- add support for cabal test-suites (introduced in Cabal-1.8)
35 kosmikus 1.1
36 dcoutts 1.11 inherit ghc-package multilib
37 kosmikus 1.1
38 slyfox 1.24 # @ECLASS-VARIABLE: CABAL_EXTRA_CONFIGURE_FLAGS
39     # @DESCRIPTION:
40     # User-specified additional parameters passed to 'setup configure'.
41 zmedico 1.39 # example: /etc/portage/make.conf: CABAL_EXTRA_CONFIGURE_FLAGS=--enable-shared
42 slyfox 1.24 : ${CABAL_EXTRA_CONFIGURE_FLAGS:=}
43    
44 slyfox 1.27 # @ECLASS-VARIABLE: CABAL_EXTRA_BUILD_FLAGS
45     # @DESCRIPTION:
46     # User-specified additional parameters passed to 'setup build'.
47 zmedico 1.39 # example: /etc/portage/make.conf: CABAL_EXTRA_BUILD_FLAGS=-v
48 slyfox 1.27 : ${CABAL_EXTRA_BUILD_FLAGS:=}
49    
50 slyfox 1.24 # @ECLASS-VARIABLE: GHC_BOOTSTRAP_FLAGS
51     # @DESCRIPTION:
52     # User-specified additional parameters for ghc when building
53     # _only_ 'setup' binary bootstrap.
54 zmedico 1.39 # example: /etc/portage/make.conf: GHC_BOOTSTRAP_FLAGS=-dynamic to make
55 slyfox 1.24 # linking 'setup' faster.
56     : ${GHC_BOOTSTRAP_FLAGS:=}
57    
58 slyfox 1.36 # @ECLASS-VARIABLE: CABAL_DEBUG_LOOSENING
59     # @DESCRIPTION:
60     # Show debug output for 'cabal_chdeps' function if set.
61     # Needs working 'diff'.
62     : ${CABAL_DEBUG_LOOSENING:=}
63    
64 kolmodin 1.19 HASKELL_CABAL_EXPF="pkg_setup src_compile src_test src_install"
65    
66     case "${EAPI:-0}" in
67 axs 1.34 2|3|4|5) HASKELL_CABAL_EXPF+=" src_configure" ;;
68 kolmodin 1.19 *) ;;
69     esac
70    
71     EXPORT_FUNCTIONS ${HASKELL_CABAL_EXPF}
72 kosmikus 1.1
73     for feature in ${CABAL_FEATURES}; do
74     case ${feature} in
75 kolmodin 1.16 haddock) CABAL_USE_HADDOCK=yes;;
76 kolmodin 1.21 hscolour) CABAL_USE_HSCOLOUR=yes;;
77 slyfox 1.26 hoogle) CABAL_USE_HOOGLE=yes;;
78 kolmodin 1.16 alex) CABAL_USE_ALEX=yes;;
79     happy) CABAL_USE_HAPPY=yes;;
80     c2hs) CABAL_USE_C2HS=yes;;
81     cpphs) CABAL_USE_CPPHS=yes;;
82     profile) CABAL_USE_PROFILE=yes;;
83     bootstrap) CABAL_BOOTSTRAP=yes;;
84     bin) CABAL_HAS_BINARIES=yes;;
85     lib) CABAL_HAS_LIBRARIES=yes;;
86     nocabaldep) CABAL_FROM_GHC=yes;;
87 slyfox 1.32 test-suite) CABAL_TEST_SUITE=yes;;
88 dcoutts 1.3 *) CABAL_UNKNOWN="${CABAL_UNKNOWN} ${feature}";;
89 kosmikus 1.1 esac
90     done
91    
92     if [[ -n "${CABAL_USE_HADDOCK}" ]]; then
93     IUSE="${IUSE} doc"
94 slyfox 1.28 # don't require depend on itself to build docs.
95     # ebuild bootstraps docs from just built binary
96     [[ ${CATEGORY}/${PN} = "dev-haskell/haddock" ]] || DEPEND="${DEPEND} doc? ( dev-haskell/haddock )"
97 kosmikus 1.1 fi
98    
99 kolmodin 1.21 if [[ -n "${CABAL_USE_HSCOLOUR}" ]]; then
100     IUSE="${IUSE} hscolour"
101     DEPEND="${DEPEND} hscolour? ( dev-haskell/hscolour )"
102     fi
103    
104 kosmikus 1.1 if [[ -n "${CABAL_USE_ALEX}" ]]; then
105     DEPEND="${DEPEND} dev-haskell/alex"
106     fi
107    
108     if [[ -n "${CABAL_USE_HAPPY}" ]]; then
109     DEPEND="${DEPEND} dev-haskell/happy"
110     fi
111    
112     if [[ -n "${CABAL_USE_C2HS}" ]]; then
113     DEPEND="${DEPEND} dev-haskell/c2hs"
114     fi
115    
116     if [[ -n "${CABAL_USE_CPPHS}" ]]; then
117     DEPEND="${DEPEND} dev-haskell/cpphs"
118     fi
119    
120     if [[ -n "${CABAL_USE_PROFILE}" ]]; then
121     IUSE="${IUSE} profile"
122     fi
123    
124 slyfox 1.32 if [[ -n "${CABAL_TEST_SUITE}" ]]; then
125     IUSE="${IUSE} test"
126     fi
127    
128 kosmikus 1.1 # We always use a standalone version of Cabal, rather than the one that comes
129     # with GHC. But of course we can't depend on cabal when building cabal itself.
130 dcoutts 1.14 if [[ -z ${CABAL_MIN_VERSION} ]]; then
131     CABAL_MIN_VERSION=1.1.4
132     fi
133 kolmodin 1.16 if [[ -z "${CABAL_BOOTSTRAP}" && -z "${CABAL_FROM_GHC}" ]]; then
134 dcoutts 1.11 DEPEND="${DEPEND} >=dev-haskell/cabal-${CABAL_MIN_VERSION}"
135 kosmikus 1.1 fi
136    
137 dcoutts 1.14 # returns the version of cabal currently in use
138     _CABAL_VERSION_CACHE=""
139     cabal-version() {
140     if [[ -z "${_CABAL_VERSION_CACHE}" ]]; then
141     if [[ "${CABAL_BOOTSTRAP}" ]]; then
142     # We're bootstrapping cabal, so the cabal version is the version
143     # of this package itself.
144     _CABAL_VERSION_CACHE="${PV}"
145 kolmodin 1.17 elif [[ "${CABAL_FROM_GHC}" ]]; then
146 slyfox 1.24 local cabal_package=$(echo "$(ghc-libdir)"/Cabal-*)
147     # /path/to/ghc/Cabal-${VER} -> ${VER}
148     _CABAL_VERSION_CACHE="${cabal_package/*Cabal-/}"
149 dcoutts 1.14 else
150     # We ask portage, not ghc, so that we only pick up
151     # portage-installed cabal versions.
152     _CABAL_VERSION_CACHE="$(ghc-extractportageversion dev-haskell/cabal)"
153     fi
154     fi
155     echo "${_CABAL_VERSION_CACHE}"
156     }
157    
158 kosmikus 1.1 cabal-bootstrap() {
159     local setupmodule
160 dcoutts 1.14 local cabalpackage
161 kosmikus 1.1 if [[ -f "${S}/Setup.lhs" ]]; then
162     setupmodule="${S}/Setup.lhs"
163 slyfox 1.29 elif [[ -f "${S}/Setup.hs" ]]; then
164     setupmodule="${S}/Setup.hs"
165 kosmikus 1.1 else
166 slyfox 1.29 die "No Setup.lhs or Setup.hs found"
167 kosmikus 1.1 fi
168    
169 slyfox 1.31 if [[ -z "${CABAL_BOOTSTRAP}" && -z "${CABAL_FROM_GHC}" ]] && ! ghc-sanecabal "${CABAL_MIN_VERSION}"; then
170     eerror "The package dev-haskell/cabal is not correctly installed for"
171     eerror "the currently active version of ghc ($(ghc-version)). Please"
172     eerror "run haskell-updater or re-build dev-haskell/cabal."
173     die "cabal is not correctly installed"
174     fi
175    
176 kosmikus 1.1 # We build the setup program using the latest version of
177     # cabal that we have installed
178 slyfox 1.29 cabalpackage=Cabal-$(cabal-version)
179 dcoutts 1.14 einfo "Using cabal-$(cabal-version)."
180 slyfox 1.24
181     make_setup() {
182 slyfox 1.26 set -- -package "${cabalpackage}" --make "${setupmodule}" \
183 slyfox 1.24 ${GHC_BOOTSTRAP_FLAGS} \
184     "$@" \
185     -o setup
186 slyfox 1.27 echo $(ghc-getghc) ${HCFLAGS} "$@"
187 slyfox 1.26 $(ghc-getghc) "$@"
188 slyfox 1.24 }
189     if $(ghc-supports-shared-libraries); then
190 slyfox 1.30 # # some custom build systems might use external libraries,
191     # # for which we don't have shared libs, so keep static fallback
192     # bug #411789, http://hackage.haskell.org/trac/ghc/ticket/5743#comment:3
193 slyfox 1.35 # http://hackage.haskell.org/trac/ghc/ticket/7062
194     # http://hackage.haskell.org/trac/ghc/ticket/3072
195     # ghc does not set RPATH for extralibs, thus we do it ourselves by hands
196     einfo "Prepending $(ghc-libdir) to LD_LIBRARY_PATH"
197     if [[ ${CHOST} != *-darwin* ]]; then
198     LD_LIBRARY_PATH="$(ghc-libdir)${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
199     export LD_LIBRARY_PATH
200     else
201     DYLD_LIBRARY_PATH="$(ghc-libdir)${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
202     export DYLD_LIBRARY_PATH
203     fi
204     { make_setup -dynamic "$@" && ./setup --help >/dev/null; } ||
205 slyfox 1.30 make_setup "$@" || die "compiling ${setupmodule} failed"
206 slyfox 1.24 else
207     make_setup "$@" || die "compiling ${setupmodule} failed"
208     fi
209 kosmikus 1.1 }
210    
211 dcoutts 1.14 cabal-mksetup() {
212     local setupdir
213    
214     if [[ -n $1 ]]; then
215     setupdir=$1
216     else
217     setupdir=${S}
218     fi
219    
220     rm -f "${setupdir}"/Setup.{lhs,hs}
221    
222     echo 'import Distribution.Simple; main = defaultMainWithHooks defaultUserHooks' \
223 slyfox 1.29 > $setupdir/Setup.hs || die "failed to create default Setup.hs"
224 dcoutts 1.14 }
225    
226 kolmodin 1.21 cabal-hscolour() {
227 slyfox 1.26 set -- hscolour "$@"
228     echo ./setup "$@"
229     ./setup "$@" || die "setup hscolour failed"
230 kolmodin 1.21 }
231    
232 kosmikus 1.1 cabal-haddock() {
233 slyfox 1.26 set -- haddock "$@"
234     echo ./setup "$@"
235     ./setup "$@" || die "setup haddock failed"
236 kosmikus 1.1 }
237    
238 kolmodin 1.21 cabal-hscolour-haddock() {
239     # --hyperlink-source implies calling 'setup hscolour'
240 slyfox 1.26 set -- haddock --hyperlink-source
241     echo ./setup "$@"
242     ./setup "$@" --hyperlink-source || die "setup haddock --hyperlink-source failed"
243 kolmodin 1.21 }
244    
245 kosmikus 1.1 cabal-configure() {
246 slyfox 1.23 has "${EAPI:-0}" 0 1 2 && ! use prefix && EPREFIX=
247    
248 dcoutts 1.14 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then
249 slyfox 1.23 cabalconf="${cabalconf} --with-haddock=${EPREFIX}/usr/bin/haddock"
250 dcoutts 1.14 fi
251 kosmikus 1.1 if [[ -n "${CABAL_USE_PROFILE}" ]] && use profile; then
252 dcoutts 1.2 cabalconf="${cabalconf} --enable-library-profiling"
253 kosmikus 1.1 fi
254 slyfox 1.23 if [[ -n "${CABAL_USE_ALEX}" ]]; then
255     cabalconf="${cabalconf} --with-alex=${EPREFIX}/usr/bin/alex"
256     fi
257    
258     if [[ -n "${CABAL_USE_HAPPY}" ]]; then
259     cabalconf="${cabalconf} --with-happy=${EPREFIX}/usr/bin/happy"
260     fi
261    
262     if [[ -n "${CABAL_USE_C2HS}" ]]; then
263     cabalconf="${cabalconf} --with-c2hs=${EPREFIX}/usr/bin/c2hs"
264     fi
265     if [[ -n "${CABAL_USE_CPPHS}" ]]; then
266     cabalconf="${cabalconf} --with-cpphs=${EPREFIX}/usr/bin/cpphs"
267     fi
268 slyfox 1.32 if [[ -n "${CABAL_TEST_SUITE}" ]]; then
269     cabalconf="${cabalconf} $(use_enable test tests)"
270     fi
271 slyfox 1.23
272 slyfox 1.27 local option
273     for option in ${HCFLAGS}
274     do
275     cabalconf+=" --ghc-option=$option"
276     done
277    
278 dcoutts 1.6 # Building GHCi libs on ppc64 causes "TOC overflow".
279     if use ppc64; then
280 dcoutts 1.5 cabalconf="${cabalconf} --disable-library-for-ghci"
281     fi
282 kosmikus 1.1
283 slyfox 1.24 # currently cabal does not respect CFLAGS and LDFLAGS on it's own (bug #333217)
284     # so translate LDFLAGS to ghc parameters (without filtering)
285     local flag
286     for flag in $LDFLAGS; do cabalconf="${cabalconf} --ghc-option=-optl$flag"; done
287    
288 slyfox 1.29 # disable executable stripping for the executables, as portage will
289     # strip by itself, and pre-stripping gives a QA warning.
290     # cabal versions previous to 1.4 does not strip executables, and does
291     # not accept the flag.
292     # this fixes numerous bugs, amongst them;
293     # bug #251881, bug #251882, bug #251884, bug #251886, bug #299494
294     cabalconf="${cabalconf} --disable-executable-stripping"
295    
296     cabalconf="${cabalconf} --docdir=${EPREFIX}/usr/share/doc/${PF}"
297     # As of Cabal 1.2, configure is quite quiet. For diagnostic purposes
298     # it's better if the configure chatter is in the build logs:
299     cabalconf="${cabalconf} --verbose"
300 dcoutts 1.11
301 slyfox 1.24 # We build shared version of our Cabal where ghc ships it's shared
302     # version of it. We will link ./setup as dynamic binary againt Cabal later.
303     [[ ${CATEGORY}/${PN} == "dev-haskell/cabal" ]] && \
304     $(ghc-supports-shared-libraries) && \
305     cabalconf="${cabalconf} --enable-shared"
306    
307 slyfox 1.35 if $(ghc-supports-shared-libraries); then
308     # maybe a bit lower
309     if version_is_at_least "7.7.20121114" "$(ghc-version)"; then
310     cabalconf="${cabalconf} --enable-shared"
311     fi
312     fi
313    
314 slyfox 1.26 set -- configure \
315 slyfox 1.23 --ghc --prefix="${EPREFIX}"/usr \
316 kosmikus 1.1 --with-compiler="$(ghc-getghc)" \
317     --with-hc-pkg="$(ghc-getghcpkg)" \
318 slyfox 1.23 --prefix="${EPREFIX}"/usr \
319     --libdir="${EPREFIX}"/usr/$(get_libdir) \
320 dcoutts 1.11 --libsubdir=${P}/ghc-$(ghc-version) \
321 slyfox 1.23 --datadir="${EPREFIX}"/usr/share/ \
322 dcoutts 1.11 --datasubdir=${P}/ghc-$(ghc-version) \
323 kosmikus 1.1 ${cabalconf} \
324 kosmikus 1.8 ${CABAL_CONFIGURE_FLAGS} \
325 slyfox 1.24 ${CABAL_EXTRA_CONFIGURE_FLAGS} \
326 slyfox 1.26 "$@"
327     echo ./setup "$@"
328     ./setup "$@" || die "setup configure failed"
329 kosmikus 1.1 }
330    
331     cabal-build() {
332 dcoutts 1.14 unset LANG LC_ALL LC_MESSAGES
333 slyfox 1.27 set -- build ${CABAL_EXTRA_BUILD_FLAGS} "$@"
334 slyfox 1.26 echo ./setup "$@"
335     ./setup "$@" \
336 kosmikus 1.1 || die "setup build failed"
337     }
338    
339     cabal-copy() {
340 slyfox 1.23 has "${EAPI:-0}" 0 1 2 && ! use prefix && ED=${D}
341    
342 slyfox 1.26 set -- copy --destdir="${D}" "$@"
343     echo ./setup "$@"
344     ./setup "$@" || die "setup copy failed"
345 kosmikus 1.1
346     # cabal is a bit eager about creating dirs,
347     # so remove them if they are empty
348 slyfox 1.23 rmdir "${ED}/usr/bin" 2> /dev/null
349 kosmikus 1.1 }
350    
351     cabal-pkg() {
352 kosmikus 1.9 # This does not actually register since we're using true instead
353 slyfox 1.29 # of ghc-pkg. So it just leaves the .conf file and we can
354 kosmikus 1.1 # register that ourselves (if it exists).
355 dcoutts 1.2
356 dcoutts 1.4 if [[ -n ${CABAL_HAS_LIBRARIES} ]]; then
357 slyfox 1.29 # Newer cabal can generate a package conf for us:
358     ./setup register --gen-pkg-config="${T}/${P}.conf"
359     ghc-setup-pkg "${T}/${P}.conf"
360     ghc-install-pkg
361 kosmikus 1.1 fi
362     }
363    
364 kolmodin 1.13 # Some cabal libs are bundled along with some versions of ghc
365     # eg filepath-1.0 comes with ghc-6.6.1
366     # by putting CABAL_CORE_LIB_GHC_PV="6.6.1" in an ebuild we are declaring that
367     # when building with this version of ghc, the ebuild is a dummy that is it will
368     # install no files since the package is already included with ghc.
369     # However portage still records the dependency and we can upgrade the package
370     # to a later one that's not included with ghc.
371     # You can also put a space separated list, eg CABAL_CORE_LIB_GHC_PV="6.6 6.6.1".
372     cabal-is-dummy-lib() {
373     for version in ${CABAL_CORE_LIB_GHC_PV[*]}; do
374 slyfox 1.33 [[ "$(ghc-version)" == ${version} ]] && return 0
375 kolmodin 1.13 done
376     return 1
377     }
378    
379 kosmikus 1.1 # exported function: check if cabal is correctly installed for
380     # the currently active ghc (we cannot guarantee this with portage)
381     haskell-cabal_pkg_setup() {
382 slyfox 1.38 if [[ -n ${CABAL_HAS_LIBRARIES} ]]; then
383     [[ ${RDEPEND} == *dev-lang/ghc* ]] || eqawarn "QA Notice: A library does not have runtime dependency on dev-lang/ghc."
384     fi
385 dcoutts 1.4 if [[ -z "${CABAL_HAS_BINARIES}" ]] && [[ -z "${CABAL_HAS_LIBRARIES}" ]]; then
386 slyfox 1.29 eqawarn "QA Notice: Neither bin nor lib are in CABAL_FEATURES."
387 dcoutts 1.4 fi
388 dcoutts 1.3 if [[ -n "${CABAL_UNKNOWN}" ]]; then
389 slyfox 1.29 eqawarn "QA Notice: Unknown entry in CABAL_FEATURES: ${CABAL_UNKNOWN}"
390 dcoutts 1.3 fi
391 kolmodin 1.13 if cabal-is-dummy-lib; then
392     einfo "${P} is included in ghc-${CABAL_CORE_LIB_GHC_PV}, nothing to install."
393     fi
394 kosmikus 1.1 }
395    
396 kolmodin 1.19 haskell-cabal_src_configure() {
397 slyfox 1.29 cabal-is-dummy-lib && return
398    
399     pushd "${S}" > /dev/null
400 kolmodin 1.19
401 slyfox 1.29 cabal-bootstrap
402 slyfox 1.22
403 slyfox 1.29 cabal-configure "$@"
404 kolmodin 1.19
405 slyfox 1.29 popd > /dev/null
406 kolmodin 1.19 }
407    
408     # exported function: nice alias
409     cabal_src_configure() {
410     haskell-cabal_src_configure "$@"
411     }
412    
413 kosmikus 1.1 # exported function: cabal-style bootstrap configure and compile
414     cabal_src_compile() {
415 slyfox 1.24 # it's a common mistake when one bumps ebuild to EAPI="2" (and upper)
416     # and forgets to separate src_compile() to src_configure()/src_compile().
417     # Such error leads to default src_configure and we lose all passed flags.
418     if ! has "${EAPI:-0}" 0 1; then
419     local passed_flag
420     for passed_flag in "$@"; do
421     [[ ${passed_flag} == --flags=* ]] && \
422 slyfox 1.29 eqawarn "QA Notice: Cabal option '${passed_flag}' has effect only in src_configure()"
423 slyfox 1.24 done
424     fi
425    
426 slyfox 1.29 cabal-is-dummy-lib && return
427    
428     has src_configure ${HASKELL_CABAL_EXPF} || haskell-cabal_src_configure "$@"
429     cabal-build
430 kosmikus 1.1
431 slyfox 1.29 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then
432     if [[ -n "${CABAL_USE_HSCOLOUR}" ]] && use hscolour; then
433     # hscolour and haddock
434     cabal-hscolour-haddock
435 kolmodin 1.21 else
436 slyfox 1.29 # just haddock
437     cabal-haddock
438     fi
439     else
440     if [[ -n "${CABAL_USE_HSCOLOUR}" ]] && use hscolour; then
441     # just hscolour
442     cabal-hscolour
443 kolmodin 1.13 fi
444 kosmikus 1.1 fi
445     }
446 kolmodin 1.16
447 kosmikus 1.1 haskell-cabal_src_compile() {
448 kolmodin 1.19 pushd "${S}" > /dev/null
449    
450     cabal_src_compile "$@"
451    
452     popd > /dev/null
453     }
454    
455     haskell-cabal_src_test() {
456     pushd "${S}" > /dev/null
457    
458 kolmodin 1.20 if cabal-is-dummy-lib; then
459     einfo ">>> No tests for dummy library: ${CATEGORY}/${PF}"
460     else
461     einfo ">>> Test phase [cabal test]: ${CATEGORY}/${PF}"
462 slyfox 1.26 set -- test "$@"
463     echo ./setup "$@"
464     ./setup "$@" || die "cabal test failed"
465 kolmodin 1.20 fi
466 kolmodin 1.19
467     popd > /dev/null
468 kosmikus 1.1 }
469    
470     # exported function: cabal-style copy and register
471     cabal_src_install() {
472 slyfox 1.23 has "${EAPI:-0}" 0 1 2 && ! use prefix && EPREFIX=
473    
474 slyfox 1.29 if ! cabal-is-dummy-lib; then
475 kolmodin 1.13 cabal-copy
476     cabal-pkg
477 slyfox 1.29 fi
478 kosmikus 1.1
479 slyfox 1.29 # create a dummy local package conf file for haskell-updater
480     # if it does not exist (dummy libraries and binaries w/o libraries)
481     local ghc_confdir_with_prefix="$(ghc-confdir)"
482     # remove EPREFIX
483     dodir ${ghc_confdir_with_prefix#${EPREFIX}}
484     local conf_file="${D}/$(ghc-confdir)/$(ghc-localpkgconf)"
485     [[ -e $conf_file ]] || echo '[]' > "$conf_file" || die
486 slyfox 1.33
487     # make sure installed packages do not destroy ghc's
488     # bundled packages
489     local initial_pkg_db=${ROOT}/$(ghc-libdir)/package.conf.d.initial
490     if [[ -e ${initial_pkg_db} ]]; then
491     local checked_pkg
492     for checked_pkg in $(ghc-listpkg "${conf_file}")
493     do
494     local initial_pkg
495     for initial_pkg in $(ghc-listpkg "${initial_pkg_db}"); do
496     if [[ ${checked_pkg} = ${initial_pkg} ]]; then
497     eerror "Package ${checked_pkg} is shipped with $(ghc-version)."
498     eerror "Ebuild author forgot CABAL_CORE_LIB_GHC_PV entry."
499     eerror "Found in ${initial_pkg_db}."
500     die
501     fi
502     done
503     done
504     fi
505 kosmikus 1.1 }
506 kolmodin 1.19
507 kosmikus 1.1 haskell-cabal_src_install() {
508 kolmodin 1.19 pushd "${S}" > /dev/null
509    
510 kosmikus 1.1 cabal_src_install
511 kolmodin 1.19
512     popd > /dev/null
513 kosmikus 1.1 }
514    
515 slyfox 1.38 # @FUNCTION: cabal_flag
516     # @DESCRIPTION:
517 kolmodin 1.19 # ebuild.sh:use_enable() taken as base
518     #
519     # Usage examples:
520     #
521     # CABAL_CONFIGURE_FLAGS=$(cabal_flag gui)
522     # leads to "--flags=gui" or "--flags=-gui" (useflag 'gui')
523     #
524     # CABAL_CONFIGURE_FLAGS=$(cabal_flag gtk gui)
525     # also leads to "--flags=gui" or " --flags=-gui" (useflag 'gtk')
526     #
527     cabal_flag() {
528     if [[ -z "$1" ]]; then
529     echo "!!! cabal_flag() called without a parameter." >&2
530     echo "!!! cabal_flag() <USEFLAG> [<cabal_flagname>]" >&2
531     return 1
532     fi
533    
534     local UWORD=${2:-$1}
535    
536     if use "$1"; then
537     echo "--flags=${UWORD}"
538     else
539     echo "--flags=-${UWORD}"
540     fi
541    
542     return 0
543     }
544 slyfox 1.36
545     # @FUNCTION: cabal_chdeps
546     # @DESCRIPTION:
547     # Allows easier patching of $CABAL_FILE (${S}/${PN}.cabal by default)
548     # depends
549     #
550     # Accepts argument list as pairs of substitutions: <from-string> <to-string>...
551     #
552     # Dies on error.
553     #
554     # Usage examples:
555     #
556     # src_prepare() {
557     # cabal_chdeps \
558     # 'base >= 4.2 && < 4.6' 'base >= 4.2 && < 4.7' \
559     # 'containers ==0.4.*' 'containers >= 0.4 && < 0.6'
560     #}
561     # or
562     # src_prepare() {
563     # CABAL_FILE=${S}/${MY_PN}.cabal cabal_chdeps \
564     # 'base >= 4.2 && < 4.6' 'base >= 4.2 && < 4.7'
565     # CABAL_FILE=${S}/${MY_PN}-tools.cabal cabal_chdeps \
566     # 'base == 3.*' 'base >= 4.2 && < 4.7'
567     #}
568     #
569     cabal_chdeps() {
570     local cf=${CABAL_FILE:-${S}/${PN}.cabal}
571     local from_ss # ss - substring
572     local to_ss
573     local orig_c # c - contents
574     local new_c
575    
576     [[ -f $cf ]] || die "cabal file '$cf' does not exist"
577    
578     orig_c=$(< "$cf")
579    
580     while :; do
581     from_pat=$1
582     to_str=$2
583    
584     [[ -n ${from_pat} ]] || break
585     [[ -n ${to_str} ]] || die "'${from_str}' does not have 'to' part"
586    
587 slyfox 1.37 einfo "CHDEP: '${from_pat}' -> '${to_str}'"
588    
589 slyfox 1.36 # escape pattern-like symbols
590     from_pat=${from_pat//\*/\\*}
591     from_pat=${from_pat//\[/\\[}
592    
593     new_c=${orig_c//${from_pat}/${to_str}}
594    
595     if [[ -n $CABAL_DEBUG_LOOSENING ]]; then
596     echo "${orig_c}" >"${T}/${cf}".pre
597     echo "${new_c}" >"${T}/${cf}".post
598     diff -u "${T}/${cf}".{pre,post}
599     fi
600    
601 slyfox 1.37 [[ "${orig_c}" == "${new_c}" ]] && die "no trigger for '${from_pat}'"
602 slyfox 1.36 orig_c=${new_c}
603     shift
604     shift
605     done
606    
607     echo "${new_c}" > "$cf" ||
608     die "failed to update"
609     }

  ViewVC Help
Powered by ViewVC 1.1.20